#ifndef _IMAGE_WIDGET_H_
#define _IMAGE_WIDGET_H_

#include <Fl/Fl.h>
#include <Fl/Fl_Widget.h>
#include "TargaImage.h"

class Fl_Button;

class ImageWidget : public Fl_Widget
{
    // methods
    public:
	    ImageWidget(int, int, int, int, char*);

	    void	    draw(void);	                        // FLTK draw function draws the current image.
	    void	    Set_Image(TargaImage*);             // set the image to draw
	    TargaImage* Get_Image();                        // get the current image
	    void	    Redraw_Image(void);                 // redraw the image in the window


    private:
        void PositionButtons(int imageWidth, int imageHeight);                  // position the buttons in the window
        static void LoadButtonCallback(Fl_Widget* pWidget, void* pData);        // load image button callback
        static void SaveButtonCallback(Fl_Widget* pWidget, void* pData);        // modify image button callback
        static void ModifyButtonCallback(Fl_Widget* pWidget, void* pData);      // modify image button callback


    // members
    private:
	    TargaImage* m_pImage;	                // The image to display (current image).
        Fl_Button*  m_pLoadButton;              // button to load image
        Fl_Button*  m_pSaveButton;              // button to save image
        Fl_Button*  m_pModifyButton;            // button to modify image
};


#endif
